<?php

namespace App\Classes\Jobs\Commands\V2;


use Carbon\Carbon;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\SerializesModels;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Storage;

class DeleteBulkInvoiceFilesV2CommandJob implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;


    public function handle()
    {
        Log::info(Carbon::now() . ': Start job - Delete all the bulk download files.');
        $start   = new Carbon();

        $directories = [
            storage_path('app/bulk_invoice'),
            storage_path('app/bulk_whiteform'),
        ];

        foreach ($directories as $directory) {
            $startInner   = new Carbon();
            Log::info(Carbon::now() . ' [Local] Start cleaning - ' . $directory);

            if (File::isDirectory($directory)) {
                File::cleanDirectory($directory);
                Log::info('[Local] All files have been deleted.');
            } else {
                Log::info('[Local] Directory does not exist.');
            }

            $endInner = new Carbon();
            $elapsedTime = $startInner->diff($endInner)->format('%H:%I:%S');

            Log::info(Carbon::now() . ' [Local] Process ended. ElapsedTime: ' . $elapsedTime);
        }

        $s3 = Storage::disk('s3');
        $directories = [
            'bulk_invoice',
            'bulk_whiteform',
        ];
        foreach ($directories as $directory) {
            $startInner = Carbon::now();
            Log::info(Carbon::now() . ' [S3] Start cleaning - ' . $directory);

            $objects = $s3->allFiles($directory);

            foreach ($objects as $object) {
                $s3->delete($object);
                Log::info('[S3] Deleted object: ' . $object);
            }

            Log::info('[S3] All files have been deleted.');

            $endInner = Carbon::now();
            $elapsedTime = $startInner->diff($endInner)->format('%H:%I:%S');
            Log::info(Carbon::now() . ' [S3] Process ended. ElapsedTime: ' . $elapsedTime);
        }

        $end = new Carbon();
        $elapsedTime = $start->diff($end)->format('%H:%I:%S');
        Log::info(Carbon::now() . ': End job - Delete all the bulk download files. ElapsedTime: ' . $elapsedTime . '.');
    }
}
